﻿"""
Credits for the sounds: InspectorJ
https://freesound.org/people/InspectorJ/sounds/416710/
https://freesound.org/people/InspectorJ/sounds/398714/

Credits for the background: UNCLE MUGEN
https://lemmasoft.renai.us/forums/viewtopic.php?f=52&t=17302
"""

init python:
    class fishing_class:
        def __init__(self, capacity, population, variety, skill):
            self.capacity = capacity
            self.population = population
            self.variety = variety
            self.skill = skill

            self.y = 0
            self.time = 0
            self.is_fishing = 0
        def y_reset(self):
            self.y = 0
        def regen(self): # This function can be called every night to replenish the fish population
            # The less fish there is, the less chance they have to reproduce
            if self.population < self.capacity:
                r = renpy.random.randint(0, 100)
                if r < (float(self.population)/self.capacity)*100:
                    self.population += self.population/10 
        def fish(self):
            if self.time:
                if self.time < .5:
                    fish = renpy.random.choice(self.variety)
                    msg.msg("You caught a {} fish.".format(fish))
                    self.population -= 1
                    self.time = 0
                    self.is_fishing = 0
                else:
                    self.is_fishing = 0
                    msg.msg("No fish on the hook!")
                    self.time = 0
        def cast(self):
            r = (1 + renpy.random.random()) - (float(self.population)/self.capacity)
            self.time = round(r * 4, 2) # 4 is the time multiplier, the higher this number the longer it take till a fish bites
            self.is_fishing = 1
            renpy.play("fishing/drop.ogg", "sound")
        def tick(self):
            self.time -= 0.01
            if self.time < self.skill and not self.y:
                renpy.play("fishing/splash.ogg", "sound")
                self.y = 40
            if self.time < 0:
                self.time = 0
                self.is_fishing = 0
                msg.msg("The fish got away!")


define beach_pound = fishing_class(
    100,                            # The pound Capacity
    56,                             # The fish population
    ["Small", "Medium", "Big"],     # The types of fish that lives in this pound, a loot table would be preferred
    0.5                             # Skill level, higher makes it easier to fish, another way of keeping track is preferred
)

screen fishing(p):
    modal True
    frame: # Remove
        align 1.0,0.0
        vbox:
            text "Dev info:"
            text "Fish population: {}/{}".format(p.population, p.capacity)
            text "Skill level: {}".format(p.skill)
            text "cast time: {}".format(p.time)
            button:
                align .5,.5 background "#4409" padding 20,20
                text "Replenish test"
                action Function(p.regen)

    vbox:
        align .5,.5
        spacing -180
        button:
            background None align .5,.5 focus_mask True
            add "fishing/bob.png" at fishing_caught(p.y)
            action Function(p.fish)
            at fishing_bob(p.is_fishing)
        add "fishing/water.png"
    if not p.is_fishing:
        button:
            align .5,.5 background "#0009" padding 20,20
            text _("Cast")
            action Function(p.cast)
    if p.time > 0:
        timer .01 repeat True action Function(p.tick)
    if p.y:
        timer p.skill+.5 repeat True action Function(p.y_reset)
transform fishing_bob(a):
    parallel:
        ease .4 alpha a
    parallel:
        ease .5 yoffset 20
        ease .5 yoffset 0
        repeat
transform fishing_caught(y):
    ease .2 yoffset y